unit main;

interface

uses
  DragDrop, DropSource, DragDropFile,
  ActiveX, Windows, Classes, Controls, Forms, StdCtrls, ComCtrls, ExtCtrls;

type
  TFormMain = class(TForm)
    DropFileSource1: TDropFileSource;
    Timer1: TTimer;
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    CheckBoxAsync: TCheckBox;
    Memo1: TMemo;
    Panel2: TPanel;
    procedure Timer1Timer(Sender: TObject);
    procedure StatusBar1DrawPanel(StatusBar: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);
    procedure DropFileSource1Drop(Sender: TObject; DragType: TDragType;
      var ContinueDrop: Boolean);
    procedure DropFileSource1AfterDrop(Sender: TObject;
      DragResult: TDragResult; Optimized: Boolean);
    procedure DropFileSource1GetData(Sender: TObject;
      const FormatEtc: tagFORMATETC; out Medium: tagSTGMEDIUM;
      var Handled: Boolean);
    procedure Panel2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    Tick: integer;
  public
  end;

var
  FormMain: TFormMain;

implementation

{$R *.DFM}

uses
  Graphics;

procedure TFormMain.Panel2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  StatusBar1.Panels[0].Text := '';
  if DragDetectPlus(Handle, Point(X, Y)) then
  begin
    StatusBar1.Panels[0].Text := 'Dragging data';
    DropFileSource1.Files.Clear;
    DropFileSource1.Files.Add(Application.ExeName);
    // Determine if we should perform an async drag or a normal drag.
    if (CheckBoxAsync.Checked) then
    begin
      // Create a thread to perform the drag...
      with TDropSourceThread.Create(DropFileSource1, False) do
        try
          // ...and launch it.
          Resume;
          // Wait for the thread to terminate.
          while not Terminated do
            Application.ProcessMessages;
        finally
          Free;
        end;
    end else
      // Perform a normal drag (in the main thread).
      DropFileSource1.Execute;

    StatusBar1.Panels[0].Text := 'Drop completed';
  end;
end;

procedure TFormMain.Timer1Timer(Sender: TObject);
begin
  // Update the statusbar to indicate that the application is responding to
  // messages (i.e. isn't blocked).
  Tick := (Tick + 10) mod 100;
  StatusBar1.Repaint;
end;

procedure TFormMain.StatusBar1DrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
var
  r: TRect;
begin
  // Display a progress bar in the statusbar panel.
  StatusBar.Canvas.Brush.Color := clRed;
  r := Classes.Rect(Rect.Left, Rect.Top,
    Rect.Left + MulDiv(Rect.Right-Rect.Left, Tick, 100), Rect.Bottom);
  StatusBar.Canvas.FillRect(r);

  StatusBar.Canvas.Brush.Color := StatusBar.Color;
  r.Left := r.Right;
  r.Right := Rect.Right;
  StatusBar.Canvas.FillRect(r);
end;

procedure TFormMain.DropFileSource1Drop(Sender: TObject;
  DragType: TDragType; var ContinueDrop: Boolean);
begin
  StatusBar1.Panels[0].Text := 'Target processing drop';
end;

procedure TFormMain.DropFileSource1AfterDrop(Sender: TObject;
  DragResult: TDragResult; Optimized: Boolean);
begin
  StatusBar1.Panels[0].Text := 'Target done with drop';
end;

procedure TFormMain.DropFileSource1GetData(Sender: TObject;
  const FormatEtc: tagFORMATETC; out Medium: tagSTGMEDIUM;
  var Handled: Boolean);
begin
  StatusBar1.Panels[0].Text := 'Target reading data';
end;

end.
