unit main;

interface

uses
  DragDrop,
  DropTarget,
  DropSource,
  DragDropText,
  Windows, Classes, Graphics, Forms, StdCtrls, Controls;

type
  TForm2 = class(TForm)
    Label1: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    DropTextTarget1: TDropTextTarget;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Memo3: TMemo;
    DropTextSource1: TDropTextSource;
    DropDummy1: TDropDummy;
    procedure FormDestroy(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Memo3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DropTextTarget1Enter(Sender: TObject;
      ShiftState: TShiftState; Point: TPoint; var Effect: Integer);
    procedure DropTextTarget1Leave(Sender: TObject);
    procedure DropTextTarget1Drop(Sender: TObject; ShiftState: TShiftState;
      Point: TPoint; var Effect: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
  public
  end;

var
  Form2: TForm2;

implementation

{$R *.DFM}

procedure TForm2.Memo3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  // Drop source stuff:
  // Detect drag and start drag operation
  if (DragDetectPlus(TWinControl(Sender).Handle, Point(X,Y))) then
  begin
    DropTextSource1.Text := Memo3.Lines.Text;
    DropTextSource1.Execute;
  end;
end;

procedure TForm2.FormDestroy(Sender: TObject);
begin
  // Unregister all targets
  DropTextTarget1.Unregister;
end;

procedure TForm2.CheckBox1Click(Sender: TObject);
begin
  if TCheckBox(Sender).Checked then
    DropTextTarget1.Register(Memo1)
  else
    DropTextTarget1.Unregister(Memo1);
end;

procedure TForm2.CheckBox2Click(Sender: TObject);
begin
  if TCheckBox(Sender).Checked then
    DropTextTarget1.Register(Memo2)
  else
    DropTextTarget1.Unregister(Memo2);
end;

procedure TForm2.DropTextTarget1Enter(Sender: TObject;
  ShiftState: TShiftState; Point: TPoint; var Effect: Integer);
begin
  // Highlight the current drag target.
  // Use the TDropTarget.Target property to determine which control is
  // current drop target:
  (TDropTarget(Sender).Target as TMemo).Color := clRed;
end;

procedure TForm2.DropTextTarget1Leave(Sender: TObject);
begin
  // Remove highlight
  (TDropTarget(Sender).Target as TMemo).Color := clWindow;
end;

procedure TForm2.DropTextTarget1Drop(Sender: TObject;
  ShiftState: TShiftState; Point: TPoint; var Effect: Integer);
begin
  // Copy dragged text
  (TDropTarget(Sender).Target as TMemo).Lines.Text := TDropTextTarget(Sender).Text;
  // Remove highlight
  (TDropTarget(Sender).Target as TMemo).Color := clWindow;
end;

procedure TForm2.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  i: integer;
  Control: TWinControl;
begin
  // Remove highligt from all controls
  for i := 0 to ComponentCount-1 do
    if (Components[i] is TMemo) then
      TMemo(Components[i]).Color := clWindow;

  // Demo of TDropTarget.FindTarget:
  // Highlight the control under the cursor if it is a drop target
  Control := DropTextTarget1.FindTarget((Sender as TWinControl).ClientToScreen(Point(X,Y)));
  if (Control <> nil) and (Control is TMemo) then
    TMemo(Control).Color := clLime;
end;

end.


